<?php

namespace Drupal\graphql_directives\Directives;

use Drupal\graphql\GraphQL\ResolverBuilder;
use Drupal\graphql\GraphQL\Resolver\ResolverInterface;

/**
 * User-related directive implementations.
 */
class User {

  /**
   * Retrieve the current user object.
   */
  public static function current(ResolverBuilder $builder) : ResolverInterface {
    return $builder->produce('current_user_entity');
  }

  /**
   * Retrieve a user's preferred language.
   */
  public static function preferredLanguage(ResolverBuilder $builder): ResolverInterface {
    return $builder->produce('preferred_language')
      ->map('user', $builder->fromParent());
  }

}
