<?php

namespace Drupal\Tests\graphql_directives\Kernel;

use Drupal\Tests\graphql\Kernel\GraphQLTestBase;

/**
 * Test schema assembly.
 */
class SchemaAggregatorTest extends GraphQLTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = ['graphql_directives', 'graphql_directives_test'];

  /**
   * Verify that the correct files are assembled.
   */
  public function testFileListing() : void {
    /** @var \Drupal\graphql_directives\SchemaAggregator $aggregator */
    $aggregator = $this->container->get('graphql_directives.aggregator');
    $moduleRoot = \Drupal::moduleHandler()->getModule('graphql_directives')->getPath();
    $root = DRUPAL_ROOT . '/' . $moduleRoot;
    $file = '/tests/assets/aggregation/src/schema.graphql';
    $this->assertTrue(file_exists($root . $file));
    $files = $aggregator->aggregate($moduleRoot . $file);
    $expected = array_map('realpath', [
      $root . $file,
      $root . '/directives.gql',
      $root . '/tests/modules/graphql_directives_test/directives.gql',
      $root . '/tests/assets/aggregation/directives/test.gql',
    ]);
    $this->assertEquals($expected, $files);
  }

}
